
proc rulerMkTab {x y} {
    .c.c create polygon $x $y [expr $x+10] [expr $y+10] \
	    [expr $x-10] [expr $y+10]
}

proc rulerMoveTab {x y} {
	global mrk
    .c.c move active [expr $x-$mrk(x)] [expr $y-$mrk(y)]
    set mrk(x) $x
    set mrk(y) $y
}

proc makeRulers { } {
	global sld rulerpos
	if {$sld(rulersenable)} {
		set rulerpos(x) -30
		set rulerpos(y) -30
#	make horizontal ruler 
		for {set x 0} {$x < 52} {incr x} {
    		.c.c create line ${x}c -0.2c ${x}c -0.6c -width 1 -tags hruler
    		.c.c create line $x.2c -0.2c $x.2c -0.4c -width 1 -tags hruler
	    	.c.c create line $x.4c -0.2c $x.4c -0.4c -width 1 -tags hruler
    	 	.c.c create line $x.6c -0.2c $x.6c -0.4c -width 1 -tags hruler
    		.c.c create line $x.8c -0.2c $x.8c -0.4c -width 1 -tags hruler
	    	.c.c create text $x.15c -0.45c -text $x -anchor sw -tags hruler
		}
# make vertical ruler
		for {set y 0} {$y < 52} {incr y} {
    		.c.c create line -0.2c ${y}c -0.6c ${y}c -width 1 -tags vruler
    		.c.c create line -0.2c $y.2c -0.4c $y.2c -width 1 -tags vruler
	    	.c.c create line -0.2c $y.4c -0.4c $y.4c -width 1 -tags vruler
    		.c.c create line -0.2c $y.6c -0.4c $y.6c -width 1 -tags vruler
    		.c.c create line -0.2c $y.8c -0.4c $y.8c -width 1 -tags vruler
	    	.c.c create text -0.55c $y.55c -text $y -anchor se -tags vruler
		}
		moveRulers
	} else {
		.c.c delete -tags hruler
		.c.c delete -tags vruler
	}
}

proc moveRulers {} {
	global sld rulerpos
	if {$sld(rulersenable)} {
		set sr [.c.c cget -scrollregion]
		set x0 [winfo pixels .c.c [lindex $sr 0]]
		set y0 [winfo pixels .c.c [lindex $sr 1]]
		set x1 [winfo pixels .c.c [lindex $sr 2]]
		set y1 [winfo pixels .c.c [lindex $sr 3]]
## get top/left side of canvas view
		set x [expr [lindex [.c.c xview] 0]*($x1-$x0)+$x0] 
		set y [expr [lindex [.c.c yview] 0]*($y1-$y0)+$y0]
		set dx [expr $x - $rulerpos(x)]
		set dy [expr $y - $rulerpos(y)]
		set rulerpos(x) $x
		set rulerpos(y) $y
		.c.c move hruler 0 $dy
		.c.c move vruler $dx 0
		.c.c raise hruler
		.c.c raise vruler
	}
}

